#!/usr/bin/env python
# -*- encoding: utf-8 -*-
'''
@Date:2022/07/18 16:32:26
'''
from sqlalchemy import asc
from db_logic.db_base import Repository
from models.client_models import EntityClient



#用户操作业务逻辑类
class BllClient(Repository):
    def __init__(self, entityType=EntityClient):
        return super().__init__(entityType)


    # 获取客户端列表
    def get_all_client_list(self):
        return self.findList().order_by(asc(EntityClient.client_code)).all()
    
    # 根据条件查询客户端信息
    def get_filter_client(self, client_id, customer_id):
        where_list = []
        if client_id:
            where_list.append(EntityClient.client_id == client_id)
        if customer_id:
            where_list.append(EntityClient.customer_id == customer_id)
        return self.findEntity(tuple(where_list))
